<?php

### Класс для работы с базой mysql
class mysql
{
  ## ресурс базы данных
  private $link;

  ## конструктор - открываем базу
  # - настройки подключения базы
  public function __construct($conf){
    $this->link = @mysql_connect($conf['host'], $conf['user'], $conf['pwd']) or $this->err();
    @mysql_select_db($conf['db'], $this->link) or $this->err();
    # выставляем кодировку
    $this->sql('set names utf8');
  }

  ## деструктер - закрываем базу
  public function __destruct(){
    if(is_resource($this->link)){
      mysql_close($this->link);
    }
  }

  ## SQL
  # - sql запрос к базе
  public function sql($sql){
    $res = @mysql_query($sql, $this->link);
    if(mysql_errno($this->link)){
      $this->err($sql); # убиваем работу скрипта при ошибке
    }
    $a = array();
    if(is_resource($res)){
      while($r = mysql_fetch_assoc($res)){
        $a[] = $r;
      }
      mysql_free_result($res);
    }else{
      $a = mysql_insert_id($this->link);
    }
    return $a;
  }

  ## Вставляем запись в таблицу
  # - таблица
  # - массив данных
  public function insert($table, $arr){
    if(is_array($arr)){
      $av = '';
      foreach($arr as $k=>$v){
        $av .= ', "'.$this->escape($v).'"';
      }
      $key = $this->escape(implode(', ',array_keys($arr)));
      $val = substr($av, 2);
      return $this->sql('insert ignore '.$table.'('.$key.') values('.$val.')', false);
    }
    return array();
  }

  ## Изменяем данные в таблице
  # - таблица
  # - массив заменяемых значений
  # - условие отбора записей - если число значит по GUID
  public function update($table, $arr, $where=false){
    if(!$where or !is_array($arr)){
      return array();
    }
    if(is_numeric($where)){
      $where = 'guid='.$where;
    }
    $av = '';
    foreach($arr as $k=>$v){
      if(is_null($v)){
        $av .= ', '.$this->escape($k).' = default';
      }else{
        $av .= ', '.$this->escape($k).' = "'.$this->escape($v).'"';
      }
    }
    return $this->sql('update '.$table.' set '.substr($av,1).' where '.$where);
  }

  ## Удаляем из базы
  # - таблица
  # - условие, если число значит GUID
  public function delete($table, $where=false){
    if(!$where){
      return array();
    }
    if(is_numeric($where)){
      $where = 'guid='.$where;
    }
    return $this->sql('delete from '.$table.' where '.$where);
  }

  ## взять запись из таблицы по индификатору
  # - таблица
  # - индификатор
  public function guid($table, $guid){
    $x = $this->sql('select * from '.$table.' where guid = '.(int)$guid.' limit 1');
    if($x[0]){
      return $x[0];
    }else{
      return array();
    }
  }

  ## Выборка данных из базы
  # - первое значение, это SQL запрос
  # * 0..9 переменных
  public function get(){
    $x = func_get_args();
    $q = $x[0];
    $x = array_map('mysql_escape_string', $x);
    $q = sprintf($q, $x[1], $x[2], $x[3], $x[4], $x[5], $x[6], $x[7], $x[8], $x[9]);
    return $this->sql($q);
  }

  /**/

  ## экранирует спецсимволы
  # - сырая строка
  private function escape($str){
    return mysql_real_escape_string($str);
  }

  ## отображение ошибки
  # - текст ошибки
  private function err($text=false){
    if($text){
      $text = '<b>'.$text.'</b><br/>';
    }
    $text .= mysql_error();
    exit($text);
  }
}
